<script lang="ts">
  import type { PlayerId, Settings, State } from "../server";
  import { isActing } from "./actions/actionUtils";
  import Compare from "./actions/Compare.svelte";
  import CompareComplete from "./actions/CompareComplete.svelte";
  import Guess from "./actions/Guess.svelte";
  import Swap from "./actions/Swap.svelte";
  import Peek from "./actions/Peek.svelte";
  import PeekComplete from "./actions/PeekComplete.svelte";
  import Discard from "./actions/Discard.svelte";

  export let playerId: PlayerId;
  export let state: State;
  export let settings: Settings;
</script>

{#if isActing(state.phase, playerId) && state.phase.kind !== "RoundComplete"}
  {#if state.phase.kind === "Peek"}
    <div class="prompt panel">
      <Peek on:action actorId={playerId} {state} />
    </div>
  {:else if state.phase.kind === "PeekComplete"}
    <div class="prompt panel">
      <PeekComplete on:action phase={state.phase} />
    </div>
  {:else if state.phase.kind === "Guess"}
    <div class="prompt panel">
      <Guess on:action actorId={playerId} {state} {settings} />
    </div>
  {:else if state.phase.kind === "Discard"}
    <div class="prompt panel">
      <Discard on:action {state} />
    </div>
  {:else if state.phase.kind === "Swap"}
    <div class="prompt panel">
      <Swap on:action actorId={playerId} {state} />
    </div>
  {:else if state.phase.kind === "Compare"}
    <div class="prompt panel">
      <Compare on:action actorId={playerId} {state} />
    </div>
  {:else if state.phase.kind === "CompareComplete"}
    <div class="prompt panel">
      <CompareComplete on:action actorId={playerId} {state} />
    </div>
  {:else if state.phase.kind === "Draw2"}
    <div class="prompt panel">
      <em>Click card to return it to the bottom of the deck.</em>
    </div>
  {/if}
{/if}

<style>
  em {
    font-weight: 300;
  }
</style>
